## kid3 3.7.0

=== CMakeLists.txt ===
# Build Kid3 using CMake
#
# Linux:
# cmake -DCMAKE_BUILD_TYPE=Release -DWITH_APPS=Qt -DCMAKE_INSTALL_PREFIX=/usr ../kid3
# make
# make install/strip DESTDIR=$(pwd)/inst # or
# cpack
#
# Windows:
# set INCLUDE=%MSYSDIR%\local\include
# set LIB=%MSYSDIR%\local\lib
# cmake -G "MinGW Makefiles" -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX= ..\kid3
# mingw32-make
# cpack
#
# Mac OS X:
# cmake -G "Unix Makefiles" -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX= ../kid3
# make
# cpack

project(kid3)

cmake_minimum_required(VERSION 3.3)

set(BUILD_SHARED_LIBS ON CACHE BOOL "build shared libraries")
set(WITH_QML    ON CACHE BOOL "build with QML")
set(WITH_TAGLIB ON CACHE BOOL "build with TagLib")
set(WITH_MP4V2 OFF CACHE BOOL "build with mp4v2")
set(WITH_FFMPEG OFF CACHE BOOL "force use of FFmpeg for Chromaprint decoding")
set(WITH_CHROMAPRINT_FFMPEG OFF CACHE BOOL "link FFmpeg only for Chromaprint FFT")
set(WITH_GSTREAMER OFF CACHE BOOL "force use of GStreamer for Chromaprint decoding")
set(WITH_QAUDIODECODER OFF CACHE BOOL "force use of QAudioDecoder for Chromaprint decoding")
set(WITH_NO_MANCOMPRESS OFF CACHE BOOL "disable compressed manpages")
if(ANDROID)
  set(CMAKE_INSTALL_PREFIX "" CACHE PATH "install path prefix" FORCE)
  set(WITH_ID3LIB OFF CACHE BOOL "build with id3lib")
  set(WITH_VORBIS OFF CACHE BOOL "build with Ogg/Vorbis")
  set(WITH_FLAC OFF CACHE BOOL "build with FLAC")
  set(WITH_CHROMAPRINT OFF CACHE BOOL "build with Chromaprint")
else()
  set(WITH_ID3LIB ON CACHE BOOL "build with id3lib")
  set(WITH_VORBIS ON CACHE BOOL "build with Ogg/Vorbis")
  set(WITH_FLAC ON CACHE BOOL "build with FLAC")
  set(WITH_CHROMAPRINT ON CACHE BOOL "build with Chromaprint")
endif()
if(APPLE OR WIN32)
  set(WITH_DBUS OFF CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qt;CLI" CACHE STRING "build applications (Qt;CLI;Test)")
elseif(ANDROID)
  set(WITH_DBUS OFF CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qml" CACHE STRING "build applications (Qml;Qt;CLI;Test)")
else()
  set(WITH_DBUS ON CACHE BOOL "build with QtDBus")
  set(WITH_APPS "Qt;CLI;KDE" CACHE STRING "build applications (Qt;CLI;KDE;Test)")
endif()
if(WIN32)
  set(WITH_READLINE OFF CACHE BOOL "build with readline")
else()
  set(WITH_READLINE ON CACHE BOOL "build with readline")
endif()

if(DEFINED WITH_KDE)
  unset(WITH_KDE CACHE)
  message(FATAL_ERROR "The variable WITH_KDE is no longer used. The KDE and Qt "
                      "applications can now be built together using common "
                      "libraries. Use WITH_APPS with a value of \"KDE\" for "
                      "the KDE application, \"Qt\" for the Qt application, "
                      "\"CLI\" for the command line application or "
                      "\"Qt;CLI;KDE\" for all. Default is -DWITH_APPS="
                      "\"${WITH_APPS}\".")
endif()

if(WITH_APPS)
  string(TOLOWER "${WITH_APPS}" _apps_lower)
  foreach(_app ${_apps_lower})
    if(_app STREQUAL "qt")
      set(BUILD_QT_APP ON)
    elseif(_app STREQUAL "qml")
      set(BUILD_QML_APP ON)
      set(WITH_QML ON)
    elseif(_app STREQUAL "cli")
      set(BUILD_CLI_APP ON)
    elseif(_app STREQUAL "kde")
      set(BUILD_KDE_APP ON)
    elseif(_app STREQUAL "test")
      set(BUILD_TEST_APP ON)
    else()
      message(SEND_ERROR "Invalid value ${_app} in WITH_APPS. "
                         "Supported applications are \"Qt;KDE;Test\".")
    endif()
  endforeach()
endif()

if(NOT BUILD_SHARED_LIBS AND WITH_QML)
  message(WARNING "Switching off WITH_QML because of static build")
  set(WITH_QML OFF)
  set(BUILD_QML_APP OFF)
endif()


# Version information
set(CPACK_PACKAGE_VERSION_MAJOR 3)
set(CPACK_PACKAGE_VERSION_MINOR 7)
set(CPACK_PACKAGE_VERSION_PATCH 0)
set(KID3_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_PACKAGE_VERSION ${KID3_VERSION})
#set(CPACK_PACKAGE_VERSION "git20170517")
set(RELEASE_YEAR 2018)

# Platform specific default installation paths
if(APPLE)
  set(WITH_DATAROOTDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_DOCDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_TRANSLATIONSDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_QMLDIR_DEFAULT "kid3.app/Contents/Resources/qml")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT "kid3.app/Contents/MacOS")
  set(WITH_PLUGINSDIR_DEFAULT "kid3.app/Contents/PlugIns")
elseif(WIN32)
  set(WITH_DATAROOTDIR_DEFAULT ".")
  set(WITH_DOCDIR_DEFAULT ".")
  set(WITH_TRANSLATIONSDIR_DEFAULT ".")
  set(WITH_QMLDIR_DEFAULT "./qml")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
  set(WITH_PLUGINSDIR_DEFAULT "./plugins")
elseif(ANDROID)
  set(WITH_DATAROOTDIR_DEFAULT ".")
  set(WITH_DOCDIR_DEFAULT ".")
  set(WITH_TRANSLATIONSDIR_DEFAULT ":/translations")
  set(WITH_QMLDIR_DEFAULT ":/")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
  set(WITH_PLUGINSDIR_DEFAULT ".")
  set(QT_ANDROID_APP_VERSION ${KID3_VERSION})
  set(QT_ANDROID_APP_VERSION_CODE 14)
else()
  set(WITH_DATAROOTDIR_DEFAULT "share")
  set(WITH_DOCDIR_DEFAULT "share/doc/kid3-qt")
  if(BUILD_KDE_APP OR BUILD_SHARED_LIBS)
    set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3/translations")
  else()
    set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3-qt/translations")
  endif()
  set(WITH_QMLDIR_DEFAULT "share/kid3/qml")
  set(WITH_BINDIR_DEFAULT "bin")
  set(WITH_LIBDIR_DEFAULT "lib${LIB_SUFFIX}/kid3")
  set(WITH_PLUGINSDIR_DEFAULT "${WITH_LIBDIR_DEFAULT}/plugins")
endif()

set(WITH_DATAROOTDIR ${WITH_DATAROOTDIR_DEFAULT} CACHE STRING
    "data root directory relative to CMAKE_INSTALL_PREFIX")
if(BUILD_KDE_APP)
  set(WITH_DBUSDIR "share/dbus-1/interfaces" CACHE STRING
      "dbus directory relative to CMAKE_INSTALL_PREFIX")
endif()
set(WITH_DOCDIR ${WITH_DOCDIR_DEFAULT} CACHE STRING
    "documentation directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_TRANSLATIONSDIR ${WITH_TRANSLATIONSDIR_DEFAULT} CACHE STRING
    "translations directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_BINDIR ${WITH_BINDIR_DEFAULT} CACHE STRING
    "binary directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_LIBDIR ${WITH_LIBDIR_DEFAULT} CACHE STRING
    "library directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_PLUGINSDIR ${WITH_PLUGINSDIR_DEFAULT} CACHE STRING
    "plugin directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_MANDIR ${WITH_DATAROOTDIR}/man CACHE STRING
    "man documentation directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_QMLDIR ${WITH_QMLDIR_DEFAULT} CACHE STRING
    "QML directory relative to CMAKE_INSTALL_PREFIX")
if(CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX_SLASH "${CMAKE_INSTALL_PREFIX}/")
else()
  set(CMAKE_INSTALL_PREFIX_SLASH "")
endif()

if(APPLE)
  file(RELATIVE_PATH CFG_DATAROOTDIR "/kid3.app/Contents/MacOS" /${WITH_DATAROOTDIR})
  file(RELATIVE_PATH CFG_DOCDIR "/kid3.app/Contents/MacOS" /${WITH_DOCDIR})
  file(RELATIVE_PATH CFG_TRANSLATIONSDIR "/kid3.app/Contents/MacOS" /${WITH_TRANSLATIONSDIR})
  file(RELATIVE_PATH CFG_QMLDIR "/kid3.app/Contents/MacOS" /${WITH_QMLDIR})
  file(RELATIVE_PATH CFG_PLUGINSDIR "/kid3.app/Contents/MacOS" /${WITH_PLUGINSDIR})
else()
  set(CFG_DATAROOTDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DATAROOTDIR})
  set(CFG_DOCDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DOCDIR})
  set(CFG_TRANSLATIONSDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_TRANSLATIONSDIR})
  set(CFG_QMLDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_QMLDIR})
  file(RELATIVE_PATH CFG_PLUGINSDIR /${WITH_BINDIR} /${WITH_PLUGINSDIR})
endif()
if(CFG_PLUGINSDIR STREQUAL "")
  set(CFG_PLUGINSDIR ".")
endif()
if(WITH_QMLDIR MATCHES "^:/")
  set(HAVE_QMLDIR_IN_QRC 1)
endif()
if(WITH_TRANSLATIONSDIR MATCHES "^:/")
  set(HAVE_TRANSLATIONSDIR_IN_QRC 1)
endif()
set(CFG_QMLSRCDIR "${kid3_SOURCE_DIR}/src/qml")

find_package(Threads)
find_package(PythonInterp REQUIRED)
include (CheckCXXSourceCompiles)
include (CheckCXXCompilerFlag)
include (CheckLibraryExists)

# Find Qt
set(_qt5Dir)
string(REGEX MATCH "^(.*[Qq]t[/\\]?5.*).bin.qmake.*" _qt5Dir "${QT_QMAKE_EXECUTABLE}")
if(_qt5Dir)
  set(_qt5Dir ${CMAKE_MATCH_1})
endif()

if(_qt5Dir)
  set(Qt5Core_DIR "${_qt5Dir}/lib/cmake/Qt5Core")
  find_package(Qt5Core)
  if(Qt5Core_FOUND)
    message(STATUS "Qt5Core found in ${_qt5Dir}")
    set(Qt5_DIR "${_qt5Dir}/lib/cmake/Qt5")
    set(Qt5Gui_DIR "${_qt5Dir}/lib/cmake/Qt5Gui")
    set(Qt5Widgets_DIR "${_qt5Dir}/lib/cmake/Qt5Widgets")
    set(Qt5Network_DIR "${_qt5Dir}/lib/cmake/Qt5Network")
    set(Qt5Xml_DIR "${_qt5Dir}/lib/cmake/Qt5Xml")
    set(Qt5Multimedia_DIR "${_qt5Dir}/lib/cmake/Qt5Multimedia")
    set(Qt5LinguistTools_DIR "${_qt5Dir}/lib/cmake/Qt5LinguistTools")
    set(Qt5Test_DIR "${_qt5Dir}/lib/cmake/Qt5Test")
    if(WITH_DBUS)
      set(Qt5DBus_DIR "${_qt5Dir}/lib/cmake/Qt5DBus")
    endif()
    if(WITH_QML)
      set(Qt5Qml_DIR "${_qt5Dir}/lib/cmake/Qt5Qml")
      set(Qt5Quick_DIR "${_qt5Dir}/lib/cmake/Qt5Quick")
    endif()
    if(BUILD_QML_APP)
      set(Qt5Svg_DIR "${_qt5Dir}/lib/cmake/Qt5Svg")
      set(Qt5QuickControls2_DIR "${_qt5Dir}/lib/cmake/Qt5QuickControls2")
    endif()
  endif()
else()
  find_package(Qt5Core)
endif()
if(Qt5Core_FOUND)
  set(_qtComponents Core Gui Widgets Network Xml Multimedia LinguistTools Test)
  if(WITH_DBUS)
    set(_qtComponents ${_qtComponents} DBus)
  endif()
  if(WITH_QML)
    set(_qtComponents ${_qtComponents} Qml Quick)
  endif()
  if(BUILD_QML_APP)
    set(_qtComponents ${_qtComponents} Svg QuickControls2)
  endif()
  find_package(Qt5 COMPONENTS ${_qtComponents} REQUIRED)

  if(WITH_DBUS)
    set(HAVE_QTDBUS 1)
  endif()
  get_target_property(QT_LIBRARY_DIR Qt5::Core LOCATION)
  get_filename_component(QT_LIBRARY_DIR ${QT_LIBRARY_DIR} PATH)
  if(APPLE)
    # For Mac Qt5.5.0 QT_LIBRARY_DIR is wrong
    # (<installdir>/Qt5.5.0/5.5/clang_64/lib/QtCore.framework), fix it.
    string(REGEX MATCH "^(.*)/QtCore.framework$" _qt5LibDir "${QT_LIBRARY_DIR}")
    if(_qt5LibDir)
      set(QT_LIBRARY_DIR ${CMAKE_MATCH_1})
    endif()
  endif()
  if(TARGET Qt5::lupdate)
    get_target_property(QT_LUPDATE_EXECUTABLE Qt5::lupdate LOCATION)
  endif()
  if(TARGET Qt5::QJpegPlugin)
    get_target_property(QT_PLUGINS_DIR Qt5::QJpegPlugin LOCATION)
  endif()
  if(QT_PLUGINS_DIR)
    get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
    get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
  elseif(_qt5Dir)
    set(QT_PLUGINS_DIR ${_qt5Dir}/plugins)
  else()
    # Before Qt 5.2, there seems to be no way to get the plugins directory.
    # Assume it is on the same level as the bin directory.
    get_filename_component(QT_PLUGINS_DIR ${QT_LUPDATE_EXECUTABLE} PATH)
    get_filename_component(QT_PLUGINS_DIR ${QT_PLUGINS_DIR} PATH)
    set(QT_PLUGINS_DIR ${QT_PLUGINS_DIR}/plugins)
  endif()

  get_target_property(_qmakeLocation Qt5::qmake LOCATION)
  message(STATUS "Found Qt-Version ${Qt5Core_VERSION_STRING} (using ${_qmakeLocation})")
endif()

if(NOT Qt5Core_FOUND)
  message(FATAL_ERROR "Qt5 not found.")
endif()

if(LINUX_SELF_CONTAINED)
  set(CPACK_INSTALL_PREFIX "")
  # Avoid GLIBC_2.14 not found errors on older systems like Debian Wheezy.
  # http://stackoverflow.com/questions/8823267/linking-against-older-symbol-version-in-a-so-file
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -include ${CMAKE_CURRENT_SOURCE_DIR}/linux/glibc_version_nightmare.h")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -include ${CMAKE_CURRENT_SOURCE_DIR}/linux/glibc_version_nightmare.h")
  # Use RPATH instead of RUNPATH, the RPATH of the loading executable has to be used, see
  # http://blog.qt.io/blog/2011/10/28/rpath-and-runpath/
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--disable-new-dtags")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--disable-new-dtags")
endif()

# Check that QT_NO_DEBUG is defined for release configurations
foreach(_buildType RELWITHDEBINFO RELEASE MINSIZEREL)
  if(NOT CMAKE_CXX_FLAGS_${_buildType} MATCHES "-DQT_NO_DEBUG")
    set(CMAKE_CXX_FLAGS_${_buildType} "${CMAKE_CXX_FLAGS_${_buildType}} -DQT_NO_DEBUG")

=== android/CMakeLists.txt ===
include(qt-android-cmake/AddQtAndroidApk.cmake)
set(QT_ANDROID_APP_PACKAGE_NAME "net.sourceforge.kid3")
set(QT_ANDROID_APP_NAME "Kid3")
set(QT_ANDROID_BUILD_TOOLS_REVISION "23.0.1")
set(_androidPackageDir ${CMAKE_CURRENT_BINARY_DIR}/package)
configure_file(AndroidManifest.xml.in
               ${_androidPackageDir}/AndroidManifest.xml @ONLY)
add_custom_command(OUTPUT ${_androidPackageDir}/res/drawable/icon.png
  COMMAND ${CMAKE_COMMAND} -E make_directory ${_androidPackageDir}/res
  COMMAND ${CMAKE_COMMAND} -E make_directory ${_androidPackageDir}/res/drawable
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/../src/app/48-apps-kid3.png
          ${_androidPackageDir}/res/drawable/icon.png
)
add_custom_target(android-package
  DEPENDS ${_androidPackageDir}/res/drawable/icon.png)
if(CMAKE_BUILD_TYPE STREQUAL "Release")
  set(_keystorePathAlias ${CMAKE_BINARY_DIR}/ufleisch-release-key.keystore ufleisch_android)
else()
  set(_keystorePathAlias)
endif()
add_qt_android_apk(apk kid3-qml
  NAME Kid3
  PACKAGE_NAME "net.sourceforge.kid3"
  DEPENDS kid3-core kid3-gui
          musicbrainzimport discogsimport freedbimport amazonimport
          taglibmetadata kid3qml Qt5::Svg
  DEPLOYMENT_DEPENDS jar/QtAndroid-bundled.jar jar/QtAndroidBearer-bundled.jar jar/QtMultimedia-bundled.jar
    lib/libQt5Core.so lib/libQt5Xml.so lib/libQt5Network.so lib/libQt5Gui.so
    plugins/bearer/libqandroidbearer.so plugins/platforms/android/libqtforandroid.so plugins/iconengines/libqsvgicon.so
#    plugins/imageformats/libqdds.so plugins/imageformats/libqgif.so plugins/imageformats/libqicns.so plugins/imageformats/libqico.so plugins/imageformats/libqjp2.so
    plugins/imageformats/libqjpeg.so
#    plugins/imageformats/libqmng.so
    plugins/imageformats/libqsvg.so
#    plugins/imageformats/libqtga.so plugins/imageformats/libqtiff.so plugins/imageformats/libqwbmp.so plugins/imageformats/libqwebp.so
    lib/libQt5Multimedia.so lib/libQt5Qml.so
#    plugins/qmltooling/libqmldbg_qtquick2.so plugins/qmltooling/libqmldbg_tcp.so
    lib/libQt5Quick.so lib/libQt5Widgets.so lib/libQt5Svg.so
    lib/libQt5QuickControls2.so lib/libQt5QuickTemplates2.so
#    lib/libQt5MultimediaQuick_p.so plugins/mediaservice/libqtmedia_android.so plugins/audio/libqtaudio_opensles.so plugins/video/videonode/libqtsgvideonode_android.so plugins/playlistformats/libqtmultimedia_m3u.so
#    qml/Enginio/libenginioplugin.so qml/Enginio/plugins.qmltypes qml/Enginio/qmldir
#    qml/Qt/labs/folderlistmodel/libqmlfolderlistmodelplugin.so qml/Qt/labs/folderlistmodel/plugins.qmltypes qml/Qt/labs/folderlistmodel/qmldir qml/Qt/labs/settings/libqmlsettingsplugin.so qml/Qt/labs/settings/plugins.qmltypes qml/Qt/labs/settings/qmldir
#    qml/Qt/WebSockets/qmldir
#    qml/Qt3D/Input/libquick3dinputplugin.so qml/Qt3D/Input/qmldir qml/Qt3D/libquick3dcoreplugin.so qml/Qt3D/qmldir qml/Qt3D/Renderer/libquick3drendererplugin.so qml/Qt3D/Renderer/qmldir
#    qml/QtBluetooth/libdeclarative_bluetooth.so qml/QtBluetooth/plugins.qmltypes qml/QtBluetooth/qmldir
#    qml/QtCanvas3D/designer/default/Canvas3D.qml qml/QtCanvas3D/designer/images/canvas3d-icon.png qml/QtCanvas3D/designer/images/canvas3d-icon16.png qml/QtCanvas3D/designer/qtcanvas3d.metainfo qml/QtCanvas3D/libqtcanvas3d.so qml/QtCanvas3D/plugins.qmltypes qml/QtCanvas3D/qmldir
#    qml/QtGraphicalEffects/Blend.qml qml/QtGraphicalEffects/BrightnessContrast.qml qml/QtGraphicalEffects/Colorize.qml qml/QtGraphicalEffects/ColorOverlay.qml qml/QtGraphicalEffects/ConicalGradient.qml qml/QtGraphicalEffects/Desaturate.qml qml/QtGraphicalEffects/DirectionalBlur.qml qml/QtGraphicalEffects/Displace.qml qml/QtGraphicalEffects/DropShadow.qml qml/QtGraphicalEffects/FastBlur.qml qml/QtGraphicalEffects/GammaAdjust.qml qml/QtGraphicalEffects/GaussianBlur.qml qml/QtGraphicalEffects/Glow.qml qml/QtGraphicalEffects/HueSaturation.qml qml/QtGraphicalEffects/InnerShadow.qml qml/QtGraphicalEffects/LevelAdjust.qml qml/QtGraphicalEffects/LinearGradient.qml qml/QtGraphicalEffects/MaskedBlur.qml qml/QtGraphicalEffects/OpacityMask.qml qml/QtGraphicalEffects/private/FastGlow.qml qml/QtGraphicalEffects/private/FastInnerShadow.qml qml/QtGraphicalEffects/private/FastMaskedBlur.qml qml/QtGraphicalEffects/private/GaussianDirectionalBlur.qml qml/QtGraphicalEffects/private/GaussianGlow.qml qml/QtGraphicalEffects/private/GaussianInnerShadow.qml qml/QtGraphicalEffects/private/GaussianMaskedBlur.qml qml/QtGraphicalEffects/private/SourceProxy.qml qml/QtGraphicalEffects/qmldir qml/QtGraphicalEffects/RadialBlur.qml qml/QtGraphicalEffects/RadialGradient.qml qml/QtGraphicalEffects/RectangularGlow.qml qml/QtGraphicalEffects/RecursiveBlur.qml qml/QtGraphicalEffects/ThresholdMask.qml qml/QtGraphicalEffects/ZoomBlur.qml
#    qml/QtLocation/libdeclarative_location.so qml/QtLocation/plugins.qmltypes qml/QtLocation/qmldir
#    qml/QtMultimedia/libdeclarative_multimedia.so qml/QtMultimedia/plugins.qmltypes qml/QtMultimedia/qmldir qml/QtMultimedia/Video.qml
#    qml/QtNfc/libdeclarative_nfc.so qml/QtNfc/plugins.qmltypes qml/QtNfc/qmldir
#    qml/QtPositioning/libdeclarative_positioning.so qml/QtPositioning/plugins.qmltypes qml/QtPositioning/qmldir
#    qml/QtQml/Models.2/libmodelsplugin.so qml/QtQml/Models.2/plugins.qmltypes qml/QtQml/Models.2/qmldir qml/QtQml/StateMachine/libqtqmlstatemachine.so qml/QtQml/StateMachine/plugins.qmltypes qml/QtQml/StateMachine/qmldir

=== doc/CMakeLists.txt ===
# Create HTML handbook from DocBook file in language directory
macro(kid3_create_handbook _docbook)
  get_filename_component(_input ${_docbook} ABSOLUTE)
  get_filename_component(_lang ${CMAKE_CURRENT_SOURCE_DIR} NAME)
  set(_output ${CMAKE_CURRENT_BINARY_DIR}/kid3_${_lang}.html)
  set(_fixdocbook_py ${CMAKE_CURRENT_SOURCE_DIR}/../fixdocbook.py)
  set(_fixhtml_py ${CMAKE_CURRENT_SOURCE_DIR}/../fixhtml.py)
  set(_docbook_xsl ${DOCBOOK_XSL_DIR}/html/docbook.xsl)
  if(WIN32)
    # The expressions in pipes do not work for Windows,
    # so temporary files are used.
    set(_tmp_xml ${CMAKE_CURRENT_BINARY_DIR}/tmp.xml)
    set(_tmp_html ${CMAKE_CURRENT_BINARY_DIR}/tmp.html)
    add_custom_command(OUTPUT ${_tmp_xml}
      COMMAND ${PYTHON_EXECUTABLE} ${_fixdocbook_py} <${_input} >${_tmp_xml}
      DEPENDS ${_input}
    )
    add_custom_command(OUTPUT ${_tmp_html}
      COMMAND ${XSLTPROC} --novalid --nonet ${_docbook_xsl} ${_tmp_xml} >${_tmp_html}
      DEPENDS ${_tmp_xml}
    )
    add_custom_command(OUTPUT ${_output}
      COMMAND ${PYTHON_EXECUTABLE} ${_fixhtml_py} <${_tmp_html} >${_output}
      DEPENDS ${_tmp_html}
    )
  else()
    add_custom_command(OUTPUT ${_output}
      COMMAND
        ${PYTHON_EXECUTABLE} ${_fixdocbook_py} <${_input} |
        ${XSLTPROC} --novalid --nonet ${_docbook_xsl} - |
        ${PYTHON_EXECUTABLE} ${_fixhtml_py} >${_output}
      DEPENDS ${_input}
    )
  endif()
  add_custom_target("${_lang}-html-handbook" ALL DEPENDS ${_output})
  install(FILES ${_output} DESTINATION ${WITH_DOCDIR})
endmacro()

# Create handbook for KDE 5.
# Replace meinproc5 with wrapper to change DTD version, then generate KDE help.
macro(kf5_create_handbook _docbook)
  cmake_minimum_required(VERSION 3.3)
  find_package(ECM REQUIRED NO_MODULE)
  set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
  include(KDEInstallDirs)
  find_package(KF5 REQUIRED COMPONENTS DocTools)
  file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/kf5-meinproc-wrapper.py
       CONTENT "#!/usr/bin/env python
import sys, os, tempfile
args = sys.argv[1:]
docbook = args.pop()
out_fh = tempfile.NamedTemporaryFile(mode='wb')
with open(docbook, 'rb') as in_fh:
    for line in in_fh:
        line = line.replace(
            b'\"-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN\" \"dtd/kdex.dtd\"',
            b'\"-//KDE//DTD DocBook XML V4.5-Based Variant V1.1//EN\" \"dtd/kdedbx45.dtd\"')
        out_fh.write(line)
out_fh.flush()
args.append(out_fh.name)
os.execv('$<TARGET_FILE:KF5::meinproc5>', args)
")
  get_filename_component(_lang ${CMAKE_CURRENT_SOURCE_DIR} NAME)
  set(KDOCTOOLS_MEINPROC_EXECUTABLE ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/kf5-meinproc-wrapper.py)
  kdoctools_create_handbook(${_docbook} INSTALL_DESTINATION ${HTML_INSTALL_DIR}/${_lang} SUBDIR kid3)
endmacro()

if(UNIX)
  if(NOT WITH_NO_MANCOMPRESS)
    find_program(GZIP_EXECUTABLE gzip)
  endif()

  # Create man page from DocBook file in language directory
  macro(kid3_create_manpage _docbook)
    get_filename_component(_input ${_docbook} ABSOLUTE)
    get_filename_component(_lang ${CMAKE_CURRENT_SOURCE_DIR} NAME)
    set(_output ${CMAKE_CURRENT_BINARY_DIR}/kid3.1)
    set(_fixdocbook_py ${CMAKE_CURRENT_SOURCE_DIR}/../fixmandocbook.py)
    set(_docbook_xsl ${DOCBOOK_XSL_DIR}/manpages/docbook.xsl)
    add_custom_command(OUTPUT ${_output}
      COMMAND
        ${PYTHON_EXECUTABLE} ${_fixdocbook_py} <${_input} |
        ${XSLTPROC} --novalid --nonet ${_docbook_xsl} -
      DEPENDS ${_input}
    )
    if(WITH_NO_MANCOMPRESS)
      set(_gzExt "")
      set(_output_gz ${_output})
    else()
      set(_gzExt ".gz")
      set(_output_gz ${_output}${_gzExt})
      add_custom_command(OUTPUT ${_output_gz}
        COMMAND ${GZIP_EXECUTABLE} -cn ${_output} >${_output_gz}
        DEPENDS ${_output}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      )
    endif()
    add_custom_target("${_lang}-man-handbook" ALL DEPENDS ${_output_gz})
    if(_lang STREQUAL "en")
      set(_install_dir ${WITH_MANDIR}/man1)
    else()
      set(_install_dir ${WITH_MANDIR}/${_lang}/man1)
    endif()
    install(FILES ${_output_gz} DESTINATION ${_install_dir})
    if(BUILD_QT_APP)
      install(CODE
        "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink kid3.1${_gzExt} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_install_dir}/kid3-qt.1${_gzExt}\")")
    endif()
    if(BUILD_CLI_APP)
      install(CODE
        "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink kid3.1${_gzExt} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_install_dir}/kid3-cli.1${_gzExt}\")")
    endif()
  endmacro()
endif()

add_subdirectory(en)
add_subdirectory(de)

=== po/CMakeLists.txt ===
# Generate .ts files from the .po files and then convert them to .qm files.
file(GLOB _poFiles *.po)
set(_tsFiles)

foreach(_currentPoFile ${_poFiles})
  get_filename_component(_lang ${_currentPoFile} NAME_WE)
  set(_tsFiles ${_tsFiles} ${CMAKE_CURRENT_BINARY_DIR}/kid3_${_lang}.ts)
endforeach()

if(APPLE OR WIN32 OR ANDROID)
  if(NOT QT_TRANSLATIONS_DIR)
    get_target_property(QT_TRANSLATIONS_DIR Qt5::qmake LOCATION)
    get_filename_component(QT_TRANSLATIONS_DIR ${QT_TRANSLATIONS_DIR} PATH)
    get_filename_component(QT_TRANSLATIONS_DIR ${QT_TRANSLATIONS_DIR} PATH)
    set(QT_TRANSLATIONS_DIR "${QT_TRANSLATIONS_DIR}/translations")
  endif()

  # Also copy or convert the Qt language files from the Qt installation.
  set(_qtQmFiles)
  set(_qtTsFiles)

  set(_qttranslation_prefix "${QT_TRANSLATIONS_DIR}/qtbase_")
  foreach(_currentPoFile ${_poFiles})
    get_filename_component(_lang ${_currentPoFile} NAME_WE)
    if(EXISTS ${_qttranslation_prefix}${_lang}.qm)
      set(_qtQmFiles ${_qtQmFiles} ${_qttranslation_prefix}${_lang}.qm)
    elseif(EXISTS ${_qttranslation_prefix}${_lang}.ts)
      set(_qtTsFiles ${_qtTsFiles} ${_qttranslation_prefix}${_lang}.ts)
    endif()
  endforeach()
endif()

if(_tsFiles)
  add_custom_command(
     OUTPUT ${_tsFiles}
     COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/po2ts.py
       ${QT_LUPDATE_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}
       ${CMAKE_CURRENT_SOURCE_DIR}/../src
     DEPENDS ${_poFiles}
  )
endif()
if(APPLE OR WIN32)
  qt5_add_translation(_qmFiles ${_tsFiles} ${_qtTsFiles})
  add_custom_target(translations "ALL" DEPENDS ${_qmFiles})
  set(_installQmFiles ${_qmFiles} ${_qtQmFiles})
else()
  qt5_add_translation(_qmFiles ${_tsFiles})
  add_custom_target(translations "ALL" DEPENDS ${_qmFiles})
  set(_installQmFiles ${_qmFiles})
endif()
if(NOT HAVE_TRANSLATIONSDIR_IN_QRC)
  install(FILES ${_installQmFiles} DESTINATION ${WITH_TRANSLATIONSDIR})
endif()

=== doc/de/CMakeLists.txt ===
if(BUILD_KDE_APP)
  kf5_create_handbook(index.docbook)
endif()

if(BUILD_QT_APP)
  kid3_create_handbook(index.docbook)
endif()

if(UNIX)
  kid3_create_manpage(index.docbook)
endif()

=== src/app/CMakeLists.txt ===
if(BUILD_CLI_APP)
  add_subdirectory(cli)
endif()

if(BUILD_QT_APP)
  add_subdirectory(qt)
endif()

if(BUILD_QML_APP)
  add_subdirectory(qml)
endif()

if(BUILD_KDE_APP)
  set(_cmakeInstallRpath "${CMAKE_INSTALL_RPATH}")
  cmake_minimum_required(VERSION 3.3)
  find_package(ECM REQUIRED NO_MODULE)
  set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
  include(ECMInstallIcons)

  include(KDEInstallDirs)
  include(KDECompilerSettings)
  include(KDECMakeSettings)
  include(FeatureSummary)

  find_package(KF5 REQUIRED COMPONENTS Config ConfigWidgets CoreAddons WidgetsAddons XmlGui)

  if(BUILD_SHARED_LIBS)
    # KDECMakeSettings.cmake will overwrite our RPATH if LIB_INSTALL_DIR is
    # not an implicit link directory. In practice this means that most values
    # for CMAKE_INSTALL_PREFIX other than /usr will cause the RPATH to be
    # overwritten and the kid3 executable will not find its libraries.
    # This happens also for the default value /usr/local for
    # CMAKE_INSTALL_PREFIX. The RPATH is set again here to reverse this.
    set(_prefixLibdir "${CMAKE_INSTALL_PREFIX}/${WITH_LIBDIR}")
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${_prefixLibdir}" _isSystemDir)
    if("${_isSystemDir}" STREQUAL "-1")
      list(APPEND _cmakeInstallRpath ${CMAKE_INSTALL_RPATH})
      list(REMOVE_DUPLICATES _cmakeInstallRpath)
      set(CMAKE_INSTALL_RPATH "${_cmakeInstallRpath}")
    endif()
  endif()

  kde_enable_exceptions()
  add_subdirectory(kde)
  ecm_install_icons(ICONS
    sc-apps-kid3.svgz
    128-apps-kid3.png
    16-apps-kid3.png
    32-apps-kid3.png
    48-apps-kid3.png
    64-apps-kid3.png
    DESTINATION ${ICON_INSTALL_DIR}
    THEME hicolor
  )
endif()

=== src/core/CMakeLists.txt ===
option(WITH_QT_PRIVATE_HEADERS "Use private Qt headers" OFF)

qt5_wrap_cpp(core_GEN_MOC_SRCS
  utils/debugutils.h
  config/batchimportsourcesmodel.h
  config/batchimportconfig.h
  config/filterconfig.h
  config/formatconfig.h
  config/generalconfig.h
  config/importconfig.h
  config/exportconfig.h
  config/tagconfig.h
  config/fileconfig.h
  config/rendirconfig.h
  config/numbertracksconfig.h
  config/useractionsconfig.h
  config/guiconfig.h
  config/networkconfig.h
  config/playlistconfig.h
  config/serverimporterconfig.h
  config/findreplaceconfig.h
  config/mainwindowconfig.h
  config/starratingmappingsmodel.h
  tags/frame.h
  tags/framenotice.h
  import/batchimporter.h
  import/httpclient.h
  import/importclient.h
  import/serverimporter.h
  import/servertrackimporter.h
  model/audioplayer.h
  model/commandstablemodel.h
  model/dirrenamer.h
  model/downloadclient.h
  model/externalprocess.h
  model/filefilter.h
  model/fileproxymodel.h
  model/fileproxymodeliterator.h
  model/bidirfileproxymodeliterator.h
  model/framelist.h
  model/frametablemodel.h
  model/kid3application.h
  model/trackdatamodel.h
  model/tagsearcher.h
  model/timeeventmodel.h
  model/taggedfileselection.h
  model/genremodel.h
  model/frameeditorobject.h
  model/frameobjectmodel.h
  model/mprisinterface.h
  model/playlistmodel.h
  model/proxyitemselectionmodel.h
  model/filesystemmodel.h
  model/fileinfogatherer_p.h
  TARGET kid3-core
)
if(HAVE_QTDBUS)
  qt5_wrap_cpp(qtdbus_GEN_MOC_SRCS
    model/scriptinterface.h
    TARGET kid3-core
  )
endif()

add_library(kid3-core
  utils/debugutils.cpp
  utils/saferename.cpp
  utils/loadtranslation.cpp
  utils/icoreplatformtools.cpp
  utils/coreplatformtools.cpp
  config/batchimportconfig.cpp
  config/batchimportprofile.cpp
  config/batchimportsourcesmodel.cpp
  config/configstore.cpp
  config/filterconfig.cpp
  config/formatconfig.cpp
  config/generalconfig.cpp
  config/importconfig.cpp
  config/exportconfig.cpp
  config/tagconfig.cpp
  config/fileconfig.cpp
  config/rendirconfig.cpp
  config/numbertracksconfig.cpp
  config/useractionsconfig.cpp
  config/guiconfig.cpp
  config/networkconfig.cpp
  config/playlistconfig.cpp
  config/serverimporterconfig.cpp
  config/isettings.cpp
  config/kid3settings.cpp
  config/findreplaceconfig.cpp
  config/mainwindowconfig.cpp
  config/starratingmappingsmodel.cpp
  tags/attributedata.cpp
  tags/genres.cpp
  tags/formatreplacer.cpp
  tags/frame.cpp
  tags/framenotice.cpp
  tags/pictureframe.cpp
  tags/taggedfile.cpp
  tags/itaggedfilefactory.cpp
  tags/trackdata.cpp
  export/playlistcreator.cpp
  export/textexporter.cpp
  import/batchimporter.cpp
  import/httpclient.cpp
  import/importclient.cpp
  import/importparser.cpp
  import/iserverimporterfactory.cpp
  import/iservertrackimporterfactory.cpp
  import/jsonparser.cpp
  import/serverimporter.cpp
  import/servertrackimporter.cpp
  import/textimporter.cpp
  import/trackdatamatcher.cpp
  model/iabortable.cpp
  model/audioplayer.cpp
  model/commandformatreplacer.cpp
  model/commandstablemodel.cpp
  model/configtablemodel.cpp
  model/dirproxymodel.cpp
  model/dirrenamer.cpp
  model/downloadclient.cpp
  model/expressionparser.cpp
  model/externalprocess.cpp
  model/filefilter.cpp
  model/fileproxymodel.cpp
  model/fileproxymodeliterator.cpp
  model/bidirfileproxymodeliterator.cpp
  model/framelist.cpp
  model/frametablemodel.cpp
  model/iframeeditor.cpp
  model/kid3application.cpp
  model/modeliterator.cpp
  model/taggedfileiconprovider.cpp
  model/texttablemodel.cpp
  model/trackdatamodel.cpp
  model/checkablestringlistmodel.cpp
  model/tagsearcher.cpp
  model/timeeventmodel.cpp
  model/eventtimingcode.cpp
  model/tracknumbervalidator.cpp
  model/taggedfileselection.cpp
  model/genremodel.cpp
  model/pixmapprovider.cpp
  model/frameeditorobject.cpp
  model/frameobjectmodel.cpp
  model/iusercommandprocessor.cpp
  model/mprisinterface.cpp
  model/playlistmodel.cpp
  model/proxyitemselectionmodel.cpp
  model/filesystemmodel.cpp
  model/fileinfogatherer.cpp
  model/abstractfiledecorationprovider.cpp
)
if(HAVE_QTDBUS)
  target_sources(kid3-core PRIVATE model/scriptinterface.cpp)
endif()
target_sources(kid3-core PRIVATE ${core_GEN_MOC_SRCS})
if(HAVE_QTDBUS)
  target_sources(kid3-core PRIVATE ${qtdbus_GEN_MOC_SRCS})
endif()

target_include_directories(kid3-core PUBLIC utils config tags export import model)

target_compile_definitions(kid3-core
  PRIVATE KID3_BUILD_CORE_LIB
  PUBLIC QT_ASCII_CAST_WARNINGS QT_NO_CAST_TO_ASCII QT_NO_URL_CAST_FROM_STRING QT_STRICT_ITERATORS QT_NO_EXCEPTIONS QT_NO_STL
)

set_target_properties(kid3-core PROPERTIES VERSION ${KID3_VERSION})
if(CMAKE_VERSION VERSION_GREATER "3.8")
  target_compile_features(kid3-core PUBLIC cxx_std_11)
else()
  target_compile_features(kid3-core PUBLIC cxx_auto_type cxx_nullptr cxx_override)
endif()
target_link_libraries(kid3-core PUBLIC Qt5::Core Qt5::Gui Qt5::Network Qt5::Xml Qt5::Multimedia)
if(WITH_QT_PRIVATE_HEADERS)
  target_compile_definitions(kid3-core PRIVATE USE_QT_PRIVATE_HEADERS)
  target_link_libraries(kid3-core PRIVATE Qt5::CorePrivate)
endif()
if(WITH_DBUS)
  target_link_libraries(kid3-core PUBLIC Qt5::DBus)
endif()
if(PLUGIN_LIBRARIES)
  target_link_libraries(kid3-core PUBLIC ${PLUGIN_LIBRARIES})
endif()
if(APPLE)
  target_link_libraries(kid3-core PUBLIC "-framework CoreServices")
endif()

if(BUILD_SHARED_LIBS)
  install(TARGETS kid3-core
    LIBRARY DESTINATION ${WITH_LIBDIR}
    RUNTIME DESTINATION ${WITH_BINDIR})
endif()

if(BUILD_KDE_APP)
  install(FILES model/net.sourceforge.Kid3.xml
          DESTINATION ${WITH_DBUSDIR})
endif()

=== src/gui/CMakeLists.txt ===
qt5_wrap_cpp(gui_GEN_MOC_SRCS
  widgets/abstractlistedit.h
  widgets/configtable.h
  widgets/formatbox.h
  widgets/filenameformatbox.h
  widgets/tagformatbox.h
  widgets/formatlistedit.h
  widgets/frametable.h
  widgets/imageviewer.h
  widgets/playtoolbar.h
  widgets/stringlistedit.h
  widgets/timeeventeditor.h
  widgets/timestampdelegate.h
  widgets/chaptereditor.h
  widgets/tableofcontentseditor.h
  widgets/subframeseditor.h
  widgets/progresswidget.h
  widgets/frameitemdelegate.h
  widgets/tablemodeledit.h
  dialogs/batchimportdialog.h
  dialogs/batchimportsourcedialog.h
  dialogs/browsecoverartdialog.h
  dialogs/configdialogpages.h
  dialogs/downloaddialog.h
  dialogs/editframefieldsdialog.h
  dialogs/exportdialog.h
  dialogs/filterdialog.h
  dialogs/importdialog.h
  dialogs/servertrackimportdialog.h
  dialogs/numbertracksdialog.h
  dialogs/playlistdialog.h
  dialogs/rendirdialog.h
  dialogs/serverimportdialog.h
  dialogs/tagimportdialog.h
  dialogs/textimportdialog.h
  dialogs/findreplacedialog.h
  dialogs/playlisteditdialog.h
  forms/filelist.h
  forms/configurabletreeview.h
  forms/kid3form.h
  forms/basemainwindow.h
  forms/playlistview.h
  TARGET kid3-gui
)

add_library(kid3-gui
  widgets/abstractlistedit.cpp
  widgets/comboboxdelegate.cpp
  widgets/configtable.cpp
  widgets/formatbox.cpp
  widgets/filenameformatbox.cpp
  widgets/tagformatbox.cpp
  widgets/formatlistedit.cpp
  widgets/frametable.cpp
  widgets/imageviewer.cpp
  widgets/picturelabel.cpp
  widgets/playtoolbar.cpp
  widgets/stringlistedit.cpp
  widgets/timeeventeditor.cpp
  widgets/enumdelegate.cpp
  widgets/eventcodedelegate.cpp
  widgets/timestampdelegate.cpp
  widgets/chaptereditor.cpp
  widgets/tableofcontentseditor.cpp
  widgets/subframeseditor.cpp
  widgets/progresswidget.cpp
  widgets/frameitemdelegate.cpp
  widgets/tablemodeledit.cpp
  dialogs/batchimportdialog.cpp
  dialogs/batchimportsourcedialog.cpp
  dialogs/browsecoverartdialog.cpp
  dialogs/configdialogpages.cpp
  dialogs/contexthelp.cpp
  dialogs/downloaddialog.cpp
  dialogs/editframefieldsdialog.cpp
  dialogs/exportdialog.cpp
  dialogs/filterdialog.cpp
  dialogs/importdialog.cpp
  dialogs/servertrackimportdialog.cpp
  dialogs/numbertracksdialog.cpp
  dialogs/playlistdialog.cpp
  dialogs/rendirdialog.cpp
  dialogs/serverimportdialog.cpp
  dialogs/tagimportdialog.cpp
  dialogs/textimportdialog.cpp
  dialogs/findreplacedialog.cpp
  dialogs/playlisteditdialog.cpp
  dialogs/stringlisteditdialog.cpp
  forms/filelist.cpp
  forms/configurabletreeview.cpp
  forms/kid3form.cpp
  forms/basemainwindow.cpp
  forms/iplatformtools.cpp
  forms/playlistview.cpp
  ${gui_GEN_MOC_SRCS}
)

target_include_directories(kid3-gui PRIVATE widgets PUBLIC dialogs forms)

target_compile_definitions(kid3-gui PRIVATE KID3_BUILD_GUI_LIB)

set_target_properties(kid3-gui PROPERTIES VERSION ${KID3_VERSION})
target_link_libraries(kid3-gui kid3-core Qt5::Widgets)

if(BUILD_SHARED_LIBS)
  install(TARGETS kid3-gui
    LIBRARY DESTINATION ${WITH_LIBDIR}
    RUNTIME DESTINATION ${WITH_BINDIR})
endif()

=== src/qml/CMakeLists.txt ===
if(NOT HAVE_QMLDIR_IN_QRC)
  # Before starting Qt Creator, export the environment variable
  # QML_IMPORT_PATH=<qt5dir>/qml:<qt5dir>/imports
  # so that the editor supports the QML types.
  # On Linux, this can be done in ~/.xsessionrc.
  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/script
          DESTINATION ${WITH_QMLDIR}
          FILES_MATCHING PATTERN "*.qml" PATTERN "*.js")

  if(BUILD_QML_APP)
    install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/app
            DESTINATION ${WITH_QMLDIR}
            FILES_MATCHING PATTERN "*.qml" PATTERN "*.js")
    install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/icons
            DESTINATION ${WITH_QMLDIR}
            FILES_MATCHING PATTERN "*.png" PATTERN "*.svg")
  endif()

  # Only used to add the QML sources to the project.
  add_custom_target(qml-sources SOURCES
    script/ReplayGain2SoundCheck.qml
    script/ResizeAlbumArt.qml
    script/QmlConsole.qml
    script/ShowTextEncodingV1.qml
    script/ExportCsv.qml
    script/ImportCsv.qml
    script/ExtractAlbumArt.qml
    script/EmbedAlbumArt.qml
    script/EmbedLyrics.qml
    script/ExportPlaylist.qml
  )
  if(BUILD_QML_APP)
    # Only used to add the QML sources to the project.
    add_custom_target(qmlapp-sources SOURCES
      app/Main.qml
      app/MainPage.qml
      app/Collapsible.qml
      app/FrameDelegate.qml
      app/FrameEditDialog.qml
      app/FrameSelectDialog.qml
      app/MessageDialog.qml
      app/UiConstants.qml
      app/FileList.qml
      app/FileCollapsible.qml
      app/TagCollapsible.qml
      app/PictureCollapsible.qml
      app/FileSelectDialog.qml
      app/RenameDirectoryPage.qml
      app/NumberTracksDialog.qml
      app/FilterPage.qml
      app/BatchImportPage.qml
      app/AbstractSettingsPage.qml
      app/SettingsElement.qml
      app/SettingsPage.qml
      app/SettingsItem.qml
      app/AboutDialog.qml
      app/Empty.qml
      app/Standard.qml
      app/ThinDivider.qml
      app/IconButton.qml
      app/ThinDivider.qml
    )
  endif()  
endif()

=== src/app/cli/CMakeLists.txt ===
### Check for readline
set(READLINE_INCLUDE_DIR)
set(READLINE_LIBRARIES)
if(WITH_READLINE)
  find_path(READLINE_INCLUDE_DIR readline/readline.h)
  find_library(READLINE_LIBRARY readline)
  if(READLINE_INCLUDE_DIR AND READLINE_LIBRARY)
    # Check whether it needs to be linked against termcap
    set(_CMAKE_REQUIRED_INCLUDES_TMP "${CMAKE_REQUIRED_INCLUDES}")
    set(_CMAKE_REQUIRED_LIBRARIES_TMP "${CMAKE_REQUIRED_LIBRARIES}")
    set(CMAKE_REQUIRED_INCLUDES "${READLINE_INCLUDE_DIR}")
    set(CMAKE_REQUIRED_LIBRARIES "${READLINE_LIBRARY}")
    CHECK_CXX_SOURCE_COMPILES("#include<cstdio>\n#include <readline/readline.h>\nint main() {\n  readline(\"\");\n  return 0;\n}\n" READLINE_STANDALONE_FOUND)
    if(READLINE_STANDALONE_FOUND)
      set(READLINE_LIBRARIES ${READLINE_LIBRARY})
    else()
      # Check whether it works with termcap
      find_library(TERMCAP_LIBRARY termcap)
      if(TERMCAP_LIBRARY)
        set(CMAKE_REQUIRED_LIBRARIES "${READLINE_LIBRARY};${TERMCAP_LIBRARY}")
        CHECK_CXX_SOURCE_COMPILES("#include<cstdio>\n#include <readline/readline.h>\nint main() {\n  readline(\"\");\n  return 0;\n}\n" READLINE_TERMCAP_FOUND)
        if(READLINE_TERMCAP_FOUND)
          set(READLINE_LIBRARIES "${READLINE_LIBRARY};${TERMCAP_LIBRARY}")
        endif()
      endif()
    endif()
    set(CMAKE_REQUIRED_INCLUDES "${_CMAKE_REQUIRED_INCLUDES_TMP}")
    set(CMAKE_REQUIRED_LIBRARIES "${_CMAKE_REQUIRED_LIBRARIES_TMP}")
  endif()
  if(READLINE_LIBRARIES)
    message(STATUS "readline found: ${READLINE_LIBRARIES}")
    set(HAVE_READLINE 1)
  else()
    message(FATAL_ERROR "Could not find readline")
  endif()
endif()
configure_file(cliconfig.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/cliconfig.h)

add_executable(kid3-cli
  maincli.cpp
  abstractcli.cpp
  kid3cli.cpp
  clicommand.cpp
  standardiohandler.cpp
)

if(HAVE_READLINE)
  target_sources(kid3-cli PRIVATE readlinecompleter.cpp)
endif()

qt5_wrap_cpp(cli_GEN_MOC_SRCS
  abstractcli.h
  kid3cli.h
  clicommand.h
  standardiohandler.h
  TARGET kid3-cli
)
target_sources(kid3-cli PRIVATE ${cli_GEN_MOC_SRCS})

target_include_directories(kid3-cli PRIVATE ${CMAKE_CURRENT_BINARY_DIR} ${READLINE_INCLUDE_DIR})

target_link_libraries(kid3-cli kid3-core ${READLINE_LIBRARIES} -lstdc++)

if(APPLE)
  set(cli_BINDIR ${WITH_LIBDIR})
else()
  set(cli_BINDIR ${WITH_BINDIR})
endif()

install(TARGETS kid3-cli
  BUNDLE DESTINATION .
  RUNTIME DESTINATION ${cli_BINDIR})

if(LINUX_SELF_CONTAINED)
  set_target_properties(kid3-cli PROPERTIES INSTALL_RPATH "\$ORIGIN")
endif()

=== src/app/kde/CMakeLists.txt ===
add_executable(kid3
  mainkde.cpp
  kdeplatformtools.cpp
  kdemainwindow.cpp
  kdeconfigdialog.cpp
  kdesettings.cpp
)

target_link_libraries(kid3 kid3-gui KF5::ConfigCore KF5::ConfigGui KF5::ConfigWidgets KF5::CoreAddons KF5::WidgetsAddons KF5::XmlGui -lstdc++)

install(TARGETS kid3 DESTINATION ${BIN_INSTALL_DIR})
install(FILES ../kid3.desktop DESTINATION ${XDG_APPS_INSTALL_DIR}
                              RENAME net.sourceforge.kid3.desktop)
install(FILES ../kid3.appdata.xml DESTINATION "${WITH_DATAROOTDIR}/metainfo"
                                  RENAME net.sourceforge.kid3.appdata.xml)
install(FILES kid3ui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/kid3)

=== src/app/qt/CMakeLists.txt ===
add_executable(${KID3_EXECUTABLE} MACOSX_BUNDLE WIN32
  mainqt.cpp
  platformtools.cpp
  kid3mainwindow.cpp
  kid3qtapplication.cpp
  recentfilesmenu.cpp
  browserdialog.cpp
  messagedialog.cpp
  configdialog.cpp
  shortcutsmodel.cpp
  shortcutsdelegate.cpp
)
qt5_wrap_cpp(qt_GEN_MOC_SRCS
  kid3mainwindow.h
  kid3qtapplication.h
  recentfilesmenu.h
  browserdialog.h
  messagedialog.h
  configdialog.h
  shortcutsmodel.h
  shortcutsdelegate.h
  TARGET ${KID3_EXECUTABLE}
)
target_sources(${KID3_EXECUTABLE} PRIVATE ${qt_GEN_MOC_SRCS})

if(APPLE)
  # Icon and properties for .plist file
  set(MACOSX_BUNDLE_BUNDLE_NAME "Kid3")
  set(MACOSX_BUNDLE_BUNDLE_EXECUTABLE "kid3")
  set(MACOSX_BUNDLE_ICON_FILE kid3.icns)
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CPACK_PACKAGE_VERSION})
  set(MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.kid3")
  set(MACOSX_BUNDLE_COPYRIGHT "Copyright (c) 2003-${RELEASE_YEAR} Urs Fleisch")
  set_source_files_properties(kid3.icns
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  target_sources(${KID3_EXECUTABLE} PRIVATE kid3.icns)
  set_source_files_properties(qt.conf
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
  target_sources(${KID3_EXECUTABLE} PRIVATE qt.conf)
elseif(WIN32)
  if(MINGW)
    # support for Windows resource files with MinGW
    set(CMAKE_RC_COMPILER_INIT windres)
    enable_language(RC)
    set(CMAKE_RC_COMPILE_OBJECT
      "<CMAKE_RC_COMPILER> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
  endif()
  # add Windows resource file with icon
  target_sources(${KID3_EXECUTABLE} PRIVATE kid3win.rc)
endif()

if(UNIX AND NOT APPLE)
  find_program(GZIP_PROGRAM gzip)
  # install desktop file and icons for Linux
  add_custom_command(OUTPUT kid3-qt.desktop
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixdesktop.py
      <${CMAKE_CURRENT_SOURCE_DIR}/../kid3.desktop >kid3-qt.desktop
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.desktop
  )
  add_custom_target("desktop-file" ALL DEPENDS kid3-qt.desktop)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.desktop
    DESTINATION "${WITH_DATAROOTDIR}/applications"
    RENAME net.sourceforge.kid3-qt.desktop)
  add_custom_command(OUTPUT kid3-qt.appdata.xml
    COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixappdata.py
      ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.appdata.xml >kid3-qt.appdata.xml
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../kid3.appdata.xml
  )
  add_custom_target("appdata-file" ALL DEPENDS kid3-qt.appdata.xml)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.appdata.xml
    DESTINATION "${WITH_DATAROOTDIR}/metainfo"
    RENAME net.sourceforge.kid3-qt.appdata.xml)
  if(GZIP_PROGRAM)
    add_custom_command(OUTPUT kid3-qt.svg
      COMMAND ${GZIP_PROGRAM} -cdn ${CMAKE_CURRENT_SOURCE_DIR}/../sc-apps-kid3.svgz >kid3-qt.svg
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/../sc-apps-kid3.svgz
    )
    target_sources(${KID3_EXECUTABLE} PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps")
  else()
    install(FILES ../sc-apps-kid3.svgz
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps"
            RENAME kid3-qt.svgz)
  endif()
  install(FILES ../128-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/128x128/apps"
          RENAME kid3-qt.png)
  install(FILES ../64-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/64x64/apps"
          RENAME kid3-qt.png)
  install(FILES ../48-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/48x48/apps"
          RENAME kid3-qt.png)
  install(FILES ../32-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/32x32/apps"
          RENAME kid3-qt.png)
  install(FILES ../16-apps-kid3.png
          DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/16x16/apps"
          RENAME kid3-qt.png)
elseif(APPLE)
  install(FILES ../48-apps-kid3.png
          DESTINATION ${WITH_DATAROOTDIR}
          RENAME kid3.png)
endif()

qt5_add_resources(qt_GEN_RCS kid3.qrc)
target_sources(${KID3_EXECUTABLE} PRIVATE
  ${qt_GEN_RCS}
)

target_link_libraries(${KID3_EXECUTABLE} kid3-gui -lstdc++)

if(APPLE)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../../../macosx/Info.plist.in
                 ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  set_target_properties(${KID3_EXECUTABLE} PROPERTIES
      MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  if(CMAKE_CXX_COMPILER MATCHES "/osxcross/")
    # When cross compiling, CPack does not know that is should be APPLE.
    install(CODE "
  set(APPLE TRUE)
  ")
  endif()
endif()

install(TARGETS ${KID3_EXECUTABLE}
  BUNDLE DESTINATION .
  RUNTIME DESTINATION ${WITH_BINDIR})

if(LINUX_SELF_CONTAINED)
  # Change RPATH/RUNPATH of executable/library.
  macro(CHANGE_RPATH _rpath _file)
    install(CODE "
      execute_process(COMMAND chrpath -r ${_rpath} \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_file}\")
      ")
  endmacro()

  set_target_properties(${KID3_EXECUTABLE} PROPERTIES INSTALL_RPATH "\$ORIGIN")
endif()

if(APPLE OR WIN32 OR LINUX_SELF_CONTAINED)

  # Put Qt libraries and plugins into installation package to create a
  # standalone bundle on Mac OS X and Windows
  set(plugin_dest_dir ${WITH_BINDIR})
  set(bundle_app
   "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/${KID3_EXECUTABLE}")
  if(APPLE)
    set(plugin_dest_dir kid3.app/Contents/PlugIns)
    set(bundle_app "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app")
  endif()
  if(WIN32)
    set(bundle_app
      "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/kid3.exe")
  endif()
  string(REPLACE "/./" "/" bundle_app ${bundle_app})

  # Install Qt JPEG and Phonon plugins
  install(DIRECTORY "${QT_PLUGINS_DIR}/imageformats"
    DESTINATION ${plugin_dest_dir}
    FILES_MATCHING PATTERN "*jpeg${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*jpeg4${CMAKE_SHARED_LIBRARY_SUFFIX}"
                   PATTERN "*.dSYM" EXCLUDE)

  if(LINUX_SELF_CONTAINED)
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/imageformats/libqjpeg${CMAKE_SHARED_LIBRARY_SUFFIX}")
  endif()
  if(APPLE)
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
      DESTINATION kid3.app/Contents/MacOS
      FILES_MATCHING PATTERN "libqcocoa${CMAKE_SHARED_LIBRARY_SUFFIX}"
                     PATTERN "*.dSYM" EXCLUDE)
    install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libqavfmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}"
                     PATTERN "*.dSYM" EXCLUDE)
  elseif(WIN32)
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "qwindows${CMAKE_SHARED_LIBRARY_SUFFIX}")
    install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "dsengine${CMAKE_SHARED_LIBRARY_SUFFIX}")
  elseif(LINUX_SELF_CONTAINED)
    install(DIRECTORY "${QT_PLUGINS_DIR}/platforms"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libqxcb${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/platforms/libqxcb${CMAKE_SHARED_LIBRARY_SUFFIX}")
    install(DIRECTORY "${QT_PLUGINS_DIR}/mediaservice"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "libgstmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
    CHANGE_RPATH("\$ORIGIN/.." "${plugin_dest_dir}/mediaservice/libgstmediaplayer${CMAKE_SHARED_LIBRARY_SUFFIX}")
  endif()

  if(CMAKE_CROSSCOMPILING AND NOT APPLE)
    # Avoid error "/usr/bin/ldd failed: 1" from GetPrerequisites.cmake:800
    # when cross-packaging, this does not seem to be supported.
    # https://public.kitware.com/pipermail/cmake/2012-March/049497.html
    install(CODE "
    set(gp_tool DO_NOT_USE)
    ")
  endif()

  if(LINUX_SELF_CONTAINED)
    # CMake 3.11.1 gets the prerequisites type wrong if a plugin uses a
    # library which is in a parent directory but still inside the bundle.
    # Override the type from "other" to "local" in such cases.
    install(CODE "
    function(gp_resolved_file_type_override resolved_file type_var)
      if(\${\${type_var}} STREQUAL other)
        get_filename_component(bundle_app_path \"${bundle_app}\" PATH)
        string(LENGTH \"\${bundle_app_path}/\" bundle_app_length)
        string(LENGTH \"\${resolved_file}\" resolved_file_length)
        if(\${resolved_file_length} GREATER \${bundle_app_length})
          string(SUBSTRING \"\${resolved_file}\" 0 \${bundle_app_length} resolved_file_path)
          if(resolved_file_path STREQUAL \"\${bundle_app_path}/\")
            set(\${type_var} local PARENT_SCOPE)
          endif()
        endif()
      endif()
    endfunction()
    ")
  endif()

  # Install and fix up all dependencies of the executable and the plugins.
  # On Mac OS X only keep the i386 code in the Qt libraries and plugins.
  install(CODE "
    file(GLOB_RECURSE QTPLUGINS
      \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    if(APPLE)
      file(GLOB_RECURSE QTPLATFORMPLUGINS
        \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app/Contents/MacOS/platforms/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
      set(QTPLUGINS \"\${QTPLUGINS};\${QTPLATFORMPLUGINS}\")
    endif()
    file(GLOB_RECURSE KID3PLUGINS
      \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_PLUGINSDIR}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
    include(BundleUtilities)
    set(bundle_libs \"\${QTPLUGINS};\${KID3PLUGINS}\")
    if(APPLE AND BUILD_CLI_APP)
      set(bundle_libs \"\${bundle_libs};\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_LIBDIR}/kid3-cli\")
    endif()
    fixup_bundle(\"${bundle_app}\" \"\${bundle_libs}\" \"${QT_LIBRARY_DIR}\")
    ")

endif()

if(WIN32)
  # Use reduced size ICU libraries, QTBUG-29828, QTBUG-38259.
  # A folder with reduced ICU libraries can be copied to the Qt bin directory.
  get_target_property(_qtBinDir Qt5::Core LOCATION)
  get_filename_component(_qtBinDir ${_qtBinDir} PATH)
  install(DIRECTORY "${_qtBinDir}/icu_reduced/"
          DESTINATION ${WITH_BINDIR} OPTIONAL)
  # Install missing DLLs.
  file(GLOB _sslDlls "${_qtBinDir}/../../../Tools/mingw*/opt/bin/*eay32.dll")
  install(FILES "${_qtBinDir}/Qt5Xml.dll" ${_sslDlls}
          DESTINATION ${WITH_BINDIR})
endif()

if(LINUX_SELF_CONTAINED)
  # Use reduced size ICU libraries.
  # A folder with reduced ICU libraries can be copied to the Qt bin directory.
  get_target_property(_qtBinDir Qt5::qmake LOCATION)
  get_filename_component(_qtBinDir ${_qtBinDir} PATH)
  string(REPLACE "/bin" "/lib" _qtLibDir "${_qtBinDir}")
  install(CODE "
    if(EXISTS \"${_qtLibDir}/icu_reduced\")
      file(GLOB _iculibs \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/libicu*\")
      if(_iculibs)
        file(REMOVE \${_iculibs})
      endif()
    endif()
  ")
  install(DIRECTORY "${_qtLibDir}/icu_reduced/"
          DESTINATION ${WITH_BINDIR} OPTIONAL)
  # Qt searches for OpenSSL 1.0, which is not found on distributions
  # as new as Ubuntu 18.04. Install them in the application directory.
  install(FILES "${CMAKE_BINARY_DIR}/../buildroot/usr/local/ssl/libssl.so"
                "${CMAKE_BINARY_DIR}/../buildroot/usr/local/ssl/libcrypto.so"
          DESTINATION ${WITH_BINDIR})
endif()

=== debian/changelog ===
kid3 (3.7.0-2+rb2) UNRELEASED; urgency=medium

  * update

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 22 Jan 2021 11:35:05 +0800

kid3 (3.7.0-2) unstable; urgency=medium

  * Add new missing files.
    - Also add new net.sourceforge.kid3-qt.desktop file.
      Closes: #922388
  * Drop -DWITH_QT5=ON from debian/rules. Qt4 is not supported anymore.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 26 Feb 2019 15:53:42 +0100

kid3 (3.7.0-1) unstable; urgency=medium

  * New upstream release.
    - kid3-qt.desktop has been dropped.
  * Bump Standards-Version to 4.3.0.
  * Adjust debian/copyright.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 31 Dec 2018 10:18:25 +0100

kid3 (3.6.2-2) unstable; urgency=medium

  * Bump Standards-Version to 4.2.1.
  * Switch build type to RelWithDebInfo.
    Closes: #909148

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 12 Oct 2018 10:15:30 +0200

kid3 (3.6.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.2.0.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 24 Aug 2018 09:44:37 +0200

=== debian/control ===
Source: kid3
Section: kde
Priority: optional
Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Build-Depends: debhelper (>= 11),
 extra-cmake-modules,
 libkf5kio-dev,
 libkf5doctools-dev,
 qtmultimedia5-dev,
 qtdeclarative5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtdeclarative5-dev-tools,
 qml-module-qtquick2,
 cmake,
 libid3-3.8.3-dev,
 libflac++-dev,
 libvorbis-dev,
 libtag1-dev,
 libchromaprint-dev,
 libavformat-dev,
 libavcodec-dev,
 docbook-xsl,
 pkg-config,
 libreadline-dev,
 xsltproc
Standards-Version: 4.3.0
Homepage: http://kid3.sourceforge.net/

Package: kid3-core
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Audio tag editor core libraries and data
 With Kid3, an ID3 tag editor for KDE you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package contains common libraries and data used by both kid3 and kid3-qt.

Package: kid3
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: KDE audio tag editor
 With Kid3, an ID3 tag editor for KDE you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package uses KDE libraries, if you do not use KDE you should use kid3-qt.

Package: kid3-qt
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Description: Audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package does not use KDE libraries, if you use KDE you should use kid3.

Package: kid3-cli
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kid3-core (= ${binary:Version})
Breaks: kid3 (<< 3.0.2-2)
Replaces: kid3 (<< 3.0.2-2)
Description: Command line audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit tags in MP3, Ogg/Vorbis, Opus, DSF, FLAC, MPC, APE, MP4/AAC, MP2,
    Speex, TrueAudio, WavPack, WMA, WAV, AIFF files and tracker modules.
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate tags from the contents of tag fields
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs, Amazon
 .
 This package contains a command line interface for Kid3, for a GUI you can
 use kid3-qt or kid3.
